//+------------------------------------------------------------------+
//|                                      cam_H2_H5_Historical_V4.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//| Modified to chart historical camarilla pivots by MrPip           |
//| 3/28/06 Fixed problem of Sunday/Monday pivots                    |
//|         and added some ideas from goodtiding5 (Kenneth Z.)       |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Lime
#property indicator_color2 Lime
#property indicator_color3 Lime
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 Pink
#property indicator_color7 Pink

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1

//---- input parameters

extern int  GMTshift=0;
extern color LColor = Lime;
extern int fontsize=8;
extern int LabelShift=1;
extern int DrawDays=5;

double L5Buffer[];
double L4Buffer[];
double L3Buffer[];
double L2Buffer[];
double YDLBuffer[];
double S1Buffer[];
double S2Buffer[];



double L2, L3, L4, L5, PL,DrawDay, DPHPL, S1, S2, P;

double D1=0.091667;
double D2=0.183333;
double D3=0.2750;
double D4=0.55;

double prev_high=0;
double prev_low=0;
double prev_close=0;
double cur_day=0;
double prev_day=0;
double day_high=0;
double day_low=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(7);
//---- indicators
   SetIndexStyle(0,DRAW_LINE, 0,1,Lime);
   SetIndexBuffer(0,L5Buffer);
   SetIndexStyle(1,DRAW_LINE, 0,1,Lime);
   SetIndexBuffer(1,L4Buffer);
   SetIndexStyle(2,DRAW_LINE, 0,1,Lime);
   SetIndexBuffer(2,L3Buffer);
   SetIndexStyle(3,DRAW_LINE, 0,1,Lime);
   SetIndexBuffer(3,L2Buffer);
   SetIndexStyle(4,DRAW_LINE, STYLE_DOT, 1, Red);
   SetIndexBuffer(4,YDLBuffer);
   SetIndexStyle(5,DRAW_LINE, 0,1,Pink);
   SetIndexBuffer(5,S1Buffer);
   SetIndexStyle(6,DRAW_LINE, 0,1,Pink);
   SetIndexBuffer(6,S2Buffer);
   
   SetIndexLabel(0,"L5");
   SetIndexLabel(1,"L4");
   SetIndexLabel(2,"L3");
   SetIndexLabel(3,"L2");
   SetIndexLabel(4,"YesterdayLow");
   SetIndexLabel(5,"S1");
   SetIndexLabel(6,"S2");

   
//----
//   IndicatorShortName("Cam H Pivots");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   ObjectDelete("CamPivot");
   ObjectDelete("SupL2");
   ObjectDelete("SupL3");
   ObjectDelete("SupL4");
   ObjectDelete("SupL5");  
   ObjectDelete("YesterdayLow"); 
   ObjectDelete("SupS1");  
   ObjectDelete("SupS2"); 
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
if (Period()==1)
{DrawDay = (DrawDays*1440);}
if (Period()==5){DrawDay = (DrawDays*288);}
if (Period()==15){DrawDay = (DrawDays*96);}
if (Period()==30){DrawDay = (DrawDays*48);}
if (Period()==60){DrawDay = (DrawDays*24);}
if (Period()==240){DrawDay = (DrawDays*6);}

if (DrawDay>Bars) DrawDay=Bars;

  {
   int    counted_bars=IndicatorCounted();
   int cnt, limit;

//---- exit if period is greater than 4 hr charts
   if(Period() > 240)
   {
      //Alert("Error - Chart period is greater than 4 Hr.");
      return(-1); // then exit
   }
   if(counted_bars<0) return(-1);

//---- last counted bar will be recounted
//   if(counted_bars>0) counted_bars--;

//   limit=(Bars-counted_bars)-1;
   limit=DrawDay;

//---- Get new daily prices & calculate pivots

   for (cnt=limit;cnt >=0;cnt--)
   {
   	if (TimeDayOfWeek(Time[cnt]) == 0)
	   {
        cur_day = prev_day;
	   }
	   else
	   {
        cur_day = TimeDay(Time[cnt]- (GMTshift*3600));
	   }
	   
   	if (prev_day != cur_day)
   	{
	   	prev_close = Close[cnt+1];
		   prev_high = day_high;
		   prev_low = day_low;

	      day_high = High[cnt];
 	      day_low  = Low[cnt];
 	      
 	      
DPHPL = prev_high/MathMax( prev_low, 0.000001 );	      
 //L1 = prev_close - ((prev_high - prev_low)*(D1));
P = (prev_high + prev_low + prev_close)/3;//Pivot
L2 = prev_close - ((prev_high - prev_low)*(D2));
L3 = prev_close - ((prev_high - prev_low)*(D3));
L4 = prev_close - ((prev_high - prev_low)*(D4));
L5 = prev_close - (DPHPL*prev_close - prev_close);	
//L5 = prev_close - ((prev_high/prev_low)*prev_close - prev_close);  
S1 = (2*P)-prev_high;

S2 = P-(prev_high - prev_low);

//---- To display all 8 Camarilla pivots remove comment symbols below and
// add the appropriate object functions below
PL = prev_low;



		   prev_day = cur_day;
	   }
      if (High[cnt]>day_high)
      {
         day_high = High[cnt];
      }
      if (Low[cnt]<day_low)
      {
         day_low = Low[cnt];
      }
      
      
      
//         day_low=Open[cnt]; day_high=Open[cnt];
      
      

//---  Draw  Pivot lines on chart
      YDLBuffer[cnt]=prev_low;
      L5Buffer[cnt]=L5;
      L4Buffer[cnt]=L4;
      L3Buffer[cnt]=L3;
      L2Buffer[cnt]=L2;
      S1Buffer[cnt]=S1;
      S2Buffer[cnt]=S2;
      
   }

   if (cur_day == TimeDay(CurTime()))   DisplayLabels();
//----

}
   return(0);
  }

void DisplayLabels()
{ 


string L2S=DoubleToStr(L2,Digits);
string L3S=DoubleToStr(L3,Digits);
string L4S=DoubleToStr(L4,Digits);
string L5S=DoubleToStr(L5,Digits);
string YDLS=DoubleToStr(PL,Digits);
string S1S=DoubleToStr(S1,Digits);
string S2S=DoubleToStr(S2,Digits);   

      
      
      if(ObjectFind("SupL2") != 0)
      {
      ObjectCreate("SupL2", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("SupL2", "                   L2 "+L2S,fontsize,"Arial",LColor);
      }
      else
      {
         ObjectMove("SupL2", 0, Time[LabelShift],L2);
      }
      
      if(ObjectFind("SupL3") != 0)
      {
      ObjectCreate("SupL3", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("SupL3", "                   L3 "+L3S,fontsize,"Arial",LColor);
      }
      else
      {
         ObjectMove("SupL3", 0, Time[LabelShift],L3);
      }
      
      if(ObjectFind("SupL4") != 0)
      {
      ObjectCreate("SupL4", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("SupL4", "                   L4 "+L4S,fontsize,"Arial",LColor);
      }
      else
      {
         ObjectMove("SupL4", 0, Time[LabelShift],L4);
      }
      
      if(ObjectFind("SupL5") != 0)
      {
      ObjectCreate("SupL5", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("SupL5", "                   L5 "+L5S,fontsize,"Arial",LColor);
      }
      else
      {
         ObjectMove("SupL5", 0, Time[LabelShift],L5);
      }
      if(ObjectFind("YesterdayLow") != 0)
      {
      ObjectCreate("YesterdayLow", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("YesterdayLow", "                           YD Low "+YDLS,fontsize,"Arial",Red);
      }
      else
      {
         ObjectMove("YesterdayLow", 0, Time[LabelShift],PL);
      }
      if(ObjectFind("SupS1") != 0)
      {
      ObjectCreate("SupS1", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("SupS1", "                   S1 "+S1S,fontsize,"Arial",Pink);
      }
      else
      {
         ObjectMove("SupS1", 0, Time[LabelShift],S1);
      }
      if(ObjectFind("SupS2") != 0)
      {
      ObjectCreate("SupS2", OBJ_TEXT, 0, 0, 0);
      ObjectSetText("SupS2", "                   S2 "+S2S,fontsize,"Arial",Pink);
      }
      else
      {
         ObjectMove("SupS2", 0, Time[LabelShift],S2);
      }
}
//+------------------------------------------------------------------+